# .. dropped in gentoo, alive here >> let's fork it..
%define main_major 1
%define udev_scriptdir /lib/udev
%define firmwaredir /lib/firmware

# (cg) Should be last used udev  and rel +1 as old udev
%define udev_ver 182
%define udev_rel 9

%define real_name  eudev
%define eudev_version  3.2.14
%define git_rel 9e7c4e744b9e7813af9acee64b5e8549ea1fbaa3

%define libname %mklibname %{name} %{main_major}

Summary: A userspace implementation of devfs
Name: udev
Version: 251
Release: %mkrel 2
License: GPL
Group:		System/Configuration/Hardware

URL:		https://github.com/gentoo/eudev
Source0:	https://github.com/eudev-project/eudev/releases/download/v%{eudev_version}/%{real_name}-%{eudev_version}.tar.gz
Source1:	start_udev
Source3:	udev-post.init
Source5:	udev.sysconfig
Source6:	76-net.rules
Source7:	udev_net_create_ifcfg
Source8:	udev_net_action
Source9:	udev_net.sysconfig
Source10:	69-printeracl.rules
Source11:	61-mobile-zte-drakx-net.rules
Source12:	51-udev-pclos.rules
Source13:	write_cd_rules
Source14:   75-cd-aliases-generator.rules
Source15:   99-joystick-perm.rules
Source16:   50-udev-default.rules
Source17:   80-drivers.rules

# don't use inotify on block devices (= plugged and unmounted devices)
# otherwise drakxtools do unwanted stuff behind (maggy know about that but they don't care.. lol - we do)
Patch1002:	eudev-3.2.11-block-rules-drakxtools-fsedit-get_hds.patch

#firmware loading support is done by kernel, so just source the udev support
Source1007:  eudev-oe-firmware-loading-support.patch

# by_path links was dropped in the past so..bring that back   
Patch1008:   eudev-enable-by_path-links-for-ata-devices.patch
Patch1009:   eudev-enable-by_path-links-for-nvme-devices.patch

Patch1010:   eudev-3.2.11-ata_id-fixes.patch
Patch1011:   eudev-3.2.11-events-pool.patch
Patch1012:   eudev-3.2.11-restore-type-failed.patch
Patch1013:   eudev-3.2.11-restore-udev-acl.patch

#upstream
Patch10001:   eudev-USEC-INITIALIZED.patch
Patch10002:   eudev-add-mtd-ny-name-symlinks.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: sed, flex
BuildRequires: pam-devel, glib2-devel, bison
BuildRequires: findutils
BuildRequires: hwdata
BuildRequires: gobject-introspection-devel >= 1.31.1
BuildRequires: gtk-doc
BuildRequires: usbutils >= 0.82
BuildRequires: gperf
BuildRequires: libacl-devel
BuildRequires: libusb-devel
BuildRequires: kmod-devel
BuildRequires: libblkid-devel >= 2.20

Requires(pre): makedev
Requires: %{libname} = %{version}-%{release}
Requires: makedev
Requires: util-linux-ng >= 2.16

Requires: %{_lib}udev0 >= %{udev_ver}-%{udev_rel}

Provides: %{name}-tools = %{version}-%{release}
Provides: %{name} = %{udev_ver}-%{udev_rel}

Obsoletes: udev-doc
Obsoletes: hal < 0.5.15
Requires: pam

%description
The udev package contains an implementation of devfs in userspace using sysfs and netlink.
This version of udev, which is udev-%version, comes from eudev !
https://github.com/eudev-project/eudev
Eudev is a fork of systemd with the aim of isolating udev from any particular flavor of system initialization. 
In this case, the isolation is from systemd

%package -n %{libname}
Summary: Dynamic library to access %{name} device information
Group: System/Libraries

%description -n %{libname}
This package contains the dynamic library libudev, which provides access
to udev device information, and an interface to search devices in sysfs.

%package -n %{libname}-devel
Summary: Development files for libudev
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: %{libname} = %{version}-%{release}
Provides: libudev-devel = 243
Provides: udev-devel = 243
Obsoletes: libudev-devel < 243
%if 0%{__isa_bits} == 64
Provides: devel(libudev(64bit)) = %{udev_ver}-%{udev_rel}
Obsoletes: devel(libudev(64bit)) < %{udev_ver}-%{udev_rel}
%else
Provides: devel(libudev) = %{version}-%{release}
Obsoletes: devel(libudev) < %{version}-%{release}
%endif
Provides:  %{_lib}udev0-devel = %{version}-%{release}
Obsoletes:  %{_lib}udev0-devel < %{version}-%{release}

%description -n %{libname}-devel
This package contains the development files for the library libudev, a
dynamic library, which provides access to udev device information.


%prep
%setup -q -n %{real_name}-%{eudev_version} 
%autopatch -p1

autoreconf -ifv
export CFLAGS="$RPM_OPT_FLAGS -Wno-format-truncation"
%configure2_5x \
  --disable-selinux \
  --prefix=/usr \
  --with-rootprefix=/ \
  --sysconfdir=%{_sysconfdir} \
  --exec-prefix="" \
  --bindir="/sbin" \
  --sbindir="/sbin" \
  --libexecdir=/lib \
  --enable-hwdb \
  --enable-kmod \
  --enable-rule-generator \
  --enable-split-usr \
  --with-rootlibdir=/%{_lib} \
  --with-rootlibexecdir=/lib/udev \
  --enable-manpages \
  --disable-static

make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_sbindir}

make DESTDIR=$RPM_BUILD_ROOT install

rm -fr $RPM_BUILD_ROOT%{_docdir}/udev
rm -f $RPM_BUILD_ROOT/%{_libdir}/*.la

rm -f $RPM_BUILD_ROOT%{_sysconfdir}/udev/udev.rules
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/init.d/udev
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/hotplug.d/default/10-udev.hotplug

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/udev/{rules.d,makedev.d,scripts,devices}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/dev.d
mkdir -p $RPM_BUILD_ROOT%{_bindir}
touch $RPM_BUILD_ROOT%{_sysconfdir}/scsi_id.config

ln -sf ../../sbin/udevadm $RPM_BUILD_ROOT%{_bindir}/udevinfo
ln -sf ../../sbin/udevadm $RPM_BUILD_ROOT%{_bindir}/udevtest
ln -sf ../../sbin/udevadm $RPM_BUILD_ROOT%{_sbindir}/udevmonitor

ln -sf udevadm $RPM_BUILD_ROOT/sbin/udevtrigger
ln -sf udevadm $RPM_BUILD_ROOT/sbin/udevsettle
ln -sf udevadm $RPM_BUILD_ROOT/sbin/udevcontrol

mkdir -p $RPM_BUILD_ROOT%{udev_scriptdir}/{,devices}

for i in \
%ifarch ppc ppc64
        rules/arch/40-ppc.rules \
%endif
	; do
	install -m 0644 "$i"  "$RPM_BUILD_ROOT%{udev_scriptdir}/rules.d/${i##*/}"
done

mkdir -p $RPM_BUILD_ROOT%{udev_scriptdir}/{,devices}

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig

# net rules
install -m 0644 %{SOURCE6} $RPM_BUILD_ROOT%{udev_scriptdir}/rules.d/
install -m 0755 %{SOURCE7} $RPM_BUILD_ROOT%{udev_scriptdir}/net_create_ifcfg
install -m 0755 %{SOURCE8} $RPM_BUILD_ROOT%{udev_scriptdir}/net_action
install -m 0644 %{SOURCE9} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/udev_net

# missing rules
install -m 0644 %{SOURCE10} $RPM_BUILD_ROOT%{udev_scriptdir}/rules.d/
install -m 0644 %{SOURCE11} $RPM_BUILD_ROOT%{udev_scriptdir}/rules.d/
install -m 0644 %{SOURCE12} $RPM_BUILD_ROOT%{udev_scriptdir}/rules.d/
install -m 0755 %{SOURCE13} $RPM_BUILD_ROOT%{udev_scriptdir}/write_cd_rules
install -m 0644 %{SOURCE14} $RPM_BUILD_ROOT%{udev_scriptdir}/rules.d/
install -m 0644 %{SOURCE15} $RPM_BUILD_ROOT%{udev_scriptdir}/rules.d/
install -m 0644 %{SOURCE16} $RPM_BUILD_ROOT%{udev_scriptdir}/rules.d/
install -m 0644 %{SOURCE17} $RPM_BUILD_ROOT%{udev_scriptdir}/rules.d/

mkdir -p $RPM_BUILD_ROOT%{_datadir}/udev
install -m 0755 %{SOURCE1} $RPM_BUILD_ROOT/sbin/start_udev

mkdir -p -m 0755 $RPM_BUILD_ROOT%{firmwaredir}

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install -m 0755 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/udev-post

install -m 0755 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/udev

mkdir -p $RPM_BUILD_ROOT/var/lib/udev/makedev.d

# force relative symlinks
for i in $(find $RPM_BUILD_ROOT%{udev_scriptdir} -maxdepth 1 ! -type d | xargs -n 1 basename); do ln -sf ..%{udev_scriptdir}/$i $RPM_BUILD_ROOT/sbin/$i; done

# force relative symlinks not owned by eudev/udev
# these must be handled/fixed by those packages, anyway...

ln -s ..%{udev_scriptdir}/check-ptp-camera $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/console_check $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/console_init $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/gpsd.hotplug $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/hid2hci $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/iphone-set-info $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/ipod-set-info $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/kpartx_id $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/libinput-device-group $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/libinput-model-quirks $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/lmt-udev $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/mtp-probe $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/pcmcia-check-broken-cis $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/pcmcia-socket-startup $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/rename_device $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/udev-add-printer $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/udev-configure-printer $RPM_BUILD_ROOT/sbin/
ln -s ..%{udev_scriptdir}/usb_modeswitch $RPM_BUILD_ROOT/sbin/

%clean
rm -rf $RPM_BUILD_ROOT

%pre
getent group video >/dev/null || /usr/sbin/groupadd -g 82 video || :
getent group audio >/dev/null || /usr/sbin/groupadd -g 81 audio || :
getent group cdrom >/dev/null || /usr/sbin/groupadd -g 22 cdrom || :
getent group tape >/dev/null || /usr/sbin/groupadd -g 21 tape || :
getent group dialout >/dev/null || /usr/sbin/groupadd -g 83 dialout || :
getent group input >/dev/null || /usr/sbin/groupadd -g 84 input || :
getent group kvm >/dev/null || /usr/sbin/groupadd -g 85 kvm || :
getent group netdev >/dev/null || /usr/sbin/groupadd -g 86 netdev || :
getent group sgx >/dev/null || /usr/sbin/groupadd -g 87 sgx || :
getent group plugdev >/dev/null || /usr/sbin/groupadd -g 88 plugdev || :

%preun
if [ $1 = 0 -a -f %{_initrddir}/udev ]; then
	if [ -x /sbin/pidof ]; then
		pid=$(/sbin/pidof udevd)
		if [ -n "$pid" ]; then
			kill $pid
		fi
	fi
	/sbin/chkconfig --del udev
fi
if [ "$1" = 0 ]; then
	/sbin/chkconfig --del udev-post
fi
exit 0

%post
%_post_service udev-post

if [ ! -f /etc/inittab ]; then
cat >/etc/inittab << EOF
id:5:initdefault:
si::sysinit:/etc/rc.d/rc.sysinit
l0:0:wait:/etc/rc.d/rc 0
l1:1:wait:/etc/rc.d/rc 1
l2:2:wait:/etc/rc.d/rc 2
l3:3:wait:/etc/rc.d/rc 3
l4:4:wait:/etc/rc.d/rc 4
l5:5:wait:/etc/rc.d/rc 5
l6:6:wait:/etc/rc.d/rc 6
ca::ctrlaltdel:/sbin/shutdown -t3 -r now
pf::powerfail:/sbin/shutdown -f -h +2 "Power Failure; System Shutting Down"
pr:12345:powerokwait:/sbin/shutdown -c "Power Restored; Shutdown Cancelled"
1:2345:respawn:/sbin/mingetty tty1
2:2345:respawn:/sbin/mingetty tty2
3:2345:respawn:/sbin/mingetty tty3
4:2345:respawn:/sbin/mingetty tty4
5:2345:respawn:/sbin/mingetty tty5
6:2345:respawn:/sbin/mingetty tty6
~~:S:wait:/bin/sh
EOF
fi

if [ "$1" -ge "1" -a -x /sbin/pidof ]; then
	pid=$(/sbin/pidof udevd)
	if [ -n "$pid" ]; then
		kill $pid
		/sbin/udevd -d
	fi
fi
#refresh initrds
for i in $(/bin/ls /lib/modules); do
    /sbin/mkinitrd -f /boot/initrd-$i.img $i &> /dev/null
done
# reload rules on the fly
/sbin/udevadm control --reload && /sbin/udevadm trigger
exit 0

%posttrans
udevadm hwdb --update > /dev/null 2>&1 || :
/sbin/chkconfig --add udev-post
chmod g+rw,o+rw /dev/fuse

%files
%defattr(0644,root,root,0755)
%attr(0755,root,root) /sbin/*
%attr(0755,root,root) %{udev_scriptdir}/ata_id
%attr(0755,root,root) %{udev_scriptdir}/write_net_rules
%attr(0755,root,root) %{udev_scriptdir}/write_cd_rules
%attr(0755,root,root) %{udev_scriptdir}/net_action
%attr(0755,root,root) %{udev_scriptdir}/net_create_ifcfg
%attr(0644,root,root) %{_sysconfdir}/sysconfig/udev_net
%attr(0755,root,root) %{udev_scriptdir}/rule_generator.functions
%attr(0755,root,root) %{udev_scriptdir}/cdrom_id
%attr(0755,root,root) %{udev_scriptdir}/collect
%attr(0755,root,root) %{udev_scriptdir}/mtd_probe
%attr(0755,root,root) %{udev_scriptdir}/udev-acl
%attr(0755,root,root) %{udev_scriptdir}/dmi_memory_id
%attr(0755,root,root) %{udev_scriptdir}/fido_id

%attr(0755,root,root) %{_sysconfdir}/rc.d/init.d/udev-post
%{_bindir}/udevtest
%{_bindir}/udevinfo
%{_sbindir}/udevmonitor
%attr(0755,root,root) %dir %{_sysconfdir}/udev/
%attr(0755,root,root) %dir %{_sysconfdir}/udev/rules.d/
%attr(0755,root,root) %dir %{udev_scriptdir}/
%attr(0755,root,root) %dir %{udev_scriptdir}/rules.d/
%attr(0755,root,root) %dir %{udev_scriptdir}/devices/
%attr(0755,root,root) %dir %{_sysconfdir}/udev/makedev.d/

%dir %{_sysconfdir}/udev/hwdb.d
%{_sysconfdir}/udev/hwdb.d/*.hwdb

%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/sysconfig/udev

%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/udev/udev.conf
%attr(0644,root,root) %{udev_scriptdir}/rules.d/*.rules

%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/scsi_id.config

%dir %attr(0755,root,root) %{firmwaredir}
%{_mandir}/man8/udev*.8*
%{_mandir}/man7/*.7*
%{_mandir}/man5/udev*.5*

%dir %attr(0755,root,root) /var/lib/udev
%dir %attr(0755,root,root) /var/lib/udev/makedev.d

# Deprecated, but keep the ownership
%ghost %dir %{_sysconfdir}/udev/scripts/
%ghost %dir %{_sysconfdir}/udev/devices/
%ghost %dir %{_sysconfdir}/dev.d/

%attr(0755,root,root) %{udev_scriptdir}/scsi_id
%attr(0755,root,root) %{udev_scriptdir}/v4l_id

%files -n %{libname}
%defattr(-,root,root,-)
/%{_lib}/libudev.so.*

%files -n %{libname}-devel
%defattr(-,root,root,-)
%{_includedir}/libudev.h
%{_includedir}/udev.h
%{_libdir}/libudev.so
%{_libdir}/pkgconfig/libudev.pc
%{_datadir}/pkgconfig/udev.pc


%changelog
* Fri Jan 12 2024 yodelu - 251-2pclos2024
- fix(rediff) p1009
- add p10001 and p10002

* Fri Oct 06 2023 yodelu - 251-1pclos2023
- new version (eudev-3.2.14)

* Wed May 17 2023 yodelu - 243-12pclos2023
- new version (eudev 3.2.12)
- drop p1004 (shipped by s17)
- drop s1005 and s1006 (upstream fixes)

* Mon Jan 09 2023 tex - 243-11pclos2023
- fix typo in 80-drivers.rules

* Sun Jan 08 2023 tex - 243-10pclos2023
- add 80-drivers.rules
- eudev is a big pile of shit

* Fri Jan 06 2023 tex - 243-9pclos2023
- revert since no change reported
- SUBSYSTEM=="sound", GROUP="audio", \
- OPTIONS+="static_node=snd/seq", OPTIONS+="static_node=snd/timer"

* Fri Jan 06 2023 tex - 243-8pclos2023
- try to fix pulseaudio
-SUBSYSTEM=="sound",		GROUP="audio"
-KERNEL=="mixer0",		SYMLINK+="mixer"

* Fri Dec 30 2022 tex - 243-7pclos2022
- test alternate 50-udev-default.rules
- SUBSYSTEM=="usb", ENV{DEVTYPE}=="usb_device", MODE="0666"
- KERNEL=="null|zero|full|random|urandom", MODE="0666"
- SUBSYSTEM=="mem", KERNEL=="mem|kmem|port|nvram", GROUP="kmem", MODE="0640"

* Wed Dec 28 2022 yodelu - 243-6pclos2022
- restore udev-acl

* Mon Dec 26 2022 tex - 243-5pclos2022
- remove source16 as it did not improve anything
- this udev doesnt work great
- should have left things alone

* Mon Dec 26 2022 tex - 243-4pclos2022
- add mtp rules source16

* Fri Dec 23 2022 tex - 243-3pclos2022
- add joystick rules
- obsolete udev-doc

* Mon Dec 19 2022 yodelu - udev-243-2pclos2022
- restore trigger type=failed (req by udev-post) 
- clean up parts of the database created by the initrd udev (start_udev)

* Sun Dec 18 2022 yodelu - udev-243-1pclos2022
- rebuild against updates
- provide udev firmware loading support only in SRPM 'cause
  > firmware is loaded by kernel from intramfs by 
  > fw_get_filesystem_firmware() through kernel_read()
  > more fixes on kernel events pool
- req libudev0 182

* Fri May 27 2022 yodelu - udev-243-0pclos2022
- req libudev0 173 since that was used prior to eudev
- provide symlinks in /sbin
- provide printeracl, zte and pclos rules
- rename package to real systemd stripped stuff (udev)
- remove systemd specific rules

* Wed May 25 2022 yodelu - 3.2.11-2pclos2022
- drop floppy
- fix provides/requires 

* Wed May 18 2022 yodelu - 3.2.11-1pclos2022
- import
